<?php
/* Event Kalender - Kalender Editor
 - Webbausteine.de */

session_start();
include "verbindung.php";

// Anmeldung überprüfen
if (isset($_POST["anmeldung"])) {
 if (isset($NAME_PASS[$_POST["name"]]) && 
     $NAME_PASS[$_POST["name"]] === $_POST["passwort"]) {
   $_SESSION["autor"] = $_POST["name"];
   header("Location: kalendereditor.php");
 }
}
?>
<!DOCTYPE html>
<html lang="de">
  <meta charset="UTF-8">
 <head>
  <title>Kalender</title>

  <style>
  body, table, textarea {
   font-family: Verdana, Arial, Sans-Serif;
   font-size: 0.95rem;
  }

  a:link, a:visited {
   color: #529EEA;
   text-decoration: None;
  }

  a:hover {
   text-decoration: Underline;
  }

  tr th {
   background-color: #E5E5E5;
  }

  th, td {
   border: Solid 1px #ABADB3;
   white-space: Nowrap;
   padding: 3px;
  }

  tr:nth-child(even) {
   background-color: Whitesmoke;
  }

  tr:nth-child(odd) {
   background-color: White;
  }

  tr:hover {
   background-color: #EDF9FE;
  }

  td:hover {
   background-color: #DAF1FC;
  }

  span.ok {
   color: #3DCE00;
   font-weight: Bold;
  }

  span.ko {
   color: #FF0000;
   font-weight: Bold;
  }

  span.status {
   color: #00B1FF;
   font-weight: Bold;
  }

  fieldset {
   background-color: #FAFAFA;
   white-space: Nowrap;
   padding-left: 20px;
  }

  legend {
   padding: 0px 10px 0px 10px;
  }

  input, select, textarea {
   font-family: Verdana, Sans-Serif;
   font-size: 0.95rem;
   margin-top: 3px;
  }

  textarea {
   width: 470px;
   height: 200px;
  }

  h2 {
   display: Inline;
   font-weight: Normal;
  }
  </style>

  <script>
  // Ausgewählter Datensatz in die Formularfelder einfügen
  function einfuegen(Autor, Tag, Monat, Jahr, Stunde, Minute, Event, Beschreibung) {
   document.Form.autor.value = Autor;
   document.Form.tagAktuell.value = Tag;
   document.Form.monatAktuell.value = Monat;
   document.Form.jahrAktuell.value = Jahr;
   document.Form.stunde.selectedIndex = Stunde;
   document.Form.minute.selectedIndex = Minute;
   document.Form.event.value = Event;
   document.Form.beschreibung.value = Beschreibung.replace(new RegExp('~', 'gi'), "\r\n");
   document.Form.event.focus();
  }

  // Meldung Ein.- und Ausblenden
  function blende(ID) {
   document.getElementById(ID).style.display= (document.getElementById(ID).style.display=="none") ? "block" : "none";
  }
  </script>

 </head>
<body>

<form name="Form" action="kalendereditor.php" method="post">
<fieldset>
 <legend>
 <h2>Kalender - Editor</h2> 

<?php
// Anmeldung
if (!isset($_SESSION["autor"]) ||
     isset($_GET["abmeldung"])) {
 echo '</legend>
 <label>&#128100; <input type="text" name="name" autofocus="autofocus" required="required" placeholder="Name"></label> 
 <label>&#128274; <input type="password" name="passwort" required="required" placeholder="Passwort"></label> 
 <input type="submit" name="anmeldung" value="Anmelden">
';

 // Abmeldung
 if (isset($_GET["abmeldung"])) {
  unset($_SESSION["autor"]);
  $_SESSION = array();
  session_destroy();
  echo '<p><span class="ok">&#10004;</span> Abmeldung erfolgreich.</p>';
 }
 exit('</fieldset></form></body></html>');
}
else {
 echo '&emsp;&#128100; <i>' . $_SESSION["autor"] . '</i> &nbsp;&#128274; <a href="kalendereditor.php?abmeldung">Abmelden</a></legend>';
}
?>

<?php
$statuszeit = 5000; // Status-OK-Anzeige in Millisekunden (JavaScript)

// Aktionen ausführen
if (isset($_POST["aktion"])) {
 if (in_array($_POST["aktion"], ["eintragen", "aendern", "loeschen"])) {
  if (!empty($_POST["tagAktuell"]) &&
      !empty($_POST["monatAktuell"]) &&
      !empty($_POST["jahrAktuell"]) &&
      !empty($_POST["event"])) {

   // Datum überprüfen
   if (checkdate($_POST["monatAktuell"],
                       $_POST["tagAktuell"],
                       $_POST["jahrAktuell"])) {

    // Event eintragen
    if ($_POST["aktion"] == "eintragen") {
     $timestamp = mktime($_POST["stunde"], $_POST["minute"], "01", $_POST["monatAktuell"], $_POST["tagAktuell"], $_POST["jahrAktuell"]);
     $_POST["beschreibung"] = strip_tags(trim($_POST["beschreibung"]), $HTML_TAGS);
     $insert = $db->prepare("INSERT INTO `" . $TABLE_PREFIX . "_kalender`
                                           SET
                                             `tag`= :tag,
                                             `monat`= :monat,
                                             `jahr`= :jahr,
                                             `zeit`= :zeit,
                                             `event`= :event,
                                             `beschreibung`= :beschreibung,
                                             `autor`= :autor");
     if ($insert->execute([':tag'=>$_POST["tagAktuell"],
                                    ':monat'=>$_POST["monatAktuell"],
                                    ':jahr'=>$_POST["jahrAktuell"],
                                     ':zeit'=>$timestamp,
                                    ':event'=>strip_tags($_POST["event"]),
                                    ':beschreibung'=>$_POST["beschreibung"],
                                    ':autor'=>$_SESSION["autor"]])) {
      echo '<p id="OK"><span class="ok">&#10004;</span> Der Event wurde eingetragen.</p>' .
       "<script>window.setTimeout(\"blende('OK')\", " . $statuszeit . ");</script>";
     }
     else {
      echo '<p><span class="ko">&#10008;</span> Fehler beim schreiben des Events!</p>';
     }
    }

    // Event ändern
    if ($_POST["aktion"] == "aendern") {
     if (isset($_POST["id"])) {
      if ($_POST["autor"] == $_SESSION["autor"] ||
          $_SESSION["autor"] == $NAME) {
       $timestamp = mktime($_POST["stunde"], $_POST["minute"], "01", $_POST["monatAktuell"], $_POST["tagAktuell"], $_POST["jahrAktuell"]);
       $_POST["beschreibung"] = strip_tags(trim($_POST["beschreibung"]), $HTML_TAGS);
       $update = $db->prepare("UPDATE `" . $TABLE_PREFIX . "_kalender`
                                               SET
                                                `tag`= :tag,
                                                `monat`= :monat,
                                                `jahr`= :jahr,
                                                `zeit`= :zeit,
                                                `event`= :event,
                                                `beschreibung`= :beschreibung
                                                WHERE
                                                 `id` = :id");
       if ($update->execute([':tag'=>$_POST["tagAktuell"],
                                        ':monat'=>$_POST["monatAktuell"],
                                        ':jahr'=>$_POST["jahrAktuell"],
                                        ':zeit'=>$timestamp,
                                        ':event'=>strip_tags($_POST["event"]),
                                        ':beschreibung'=>$_POST["beschreibung"],
                                        ':id'=>$_POST["id"]])) {
        echo '<p id="OK"><span class="ok">&#10004;</span> Der Event wurde geändert.</p>' .
         "<script>window.setTimeout(\"blende('OK')\", " . $statuszeit . ");</script>";
       }
       else {
        echo '<p><span class="ko">&#10008;</span> Fehler beim ändern des Events!</p>';
       }
      }
      else {
       echo '<p><span class="ko">&#10008;</span> Sie können diesen Event nicht ändern!</p>';
      }
     }
     else {
      echo '<p><span class="ko">&#10008;</span> Es wurde kein Event zum ändern ausgewählt!</p>';
     }
    }

    // Event löschen
    if ($_POST["aktion"] == "loeschen") {
     if (isset($_POST["id"])) {
      if ($_POST["autor"] == $_SESSION["autor"] ||
          $_SESSION["autor"] == $NAME) {
       $delete = $db->prepare("DELETE FROM `" . $TABLE_PREFIX . "_kalender`
                                             WHERE
                                             `id` = :id");
       if ($delete->execute([':id'=>$_POST["id"]])) {
        echo '<p class="ok" id="OK"><span class="ok">&#10004;</span> Der Event wurde gelöscht.</p>' .
         "<script>window.setTimeout(\"blende('OK')\", " . $statuszeit . ");</script>";
       }
       else {
        echo '<p><span class="ko">&#10008;</span> Fehler beim löschen!</p>';
       }
      }
      else {
       echo '<p><span class="ko">&#10008;</span> Sie können diesen Event nicht löschen!</p>';
      }
     }
     else {
      echo '<p><span class="ko">&#10008;</span> Es wurde kein Event zum löschen ausgewählt!</p>';
     }
    }
   }
   else {
    echo '<p><span class="ko">&#10008;</span> ' . $_POST["tagAktuell"] . '.' . $_POST["monatAktuell"] . '.' . $_POST["jahrAktuell"] . ' - Ungültiges Datum!</p>';
   }
  }
 }
}

// Formular
$jahr = isset($_POST["jahr"]) ? $_POST["jahr"] : date("Y");
$monat = isset($_POST["monat"]) ? $_POST["monat"] : date("n");

// Auswahlliste Monat
$auswahlMonat = '&#128270; <select name="monat" onChange="document.Form.submit()">';
foreach ([1 => 'Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember']
 as $monatszahl => $Monat) {
 $auswahlMonat .= '  <option value="' . $monatszahl . '"' .
  ((isset($_POST["monat"]) ? $_POST["monat"] : date("n")) == $monatszahl ? ' selected="selected"' : "") .
  '>' . $Monat . '</option>';
}
$auswahlMonat .= ' </select>';

// Auswahlliste Jahr
$auswahlJahr = '<select name="jahr" onChange="document.Form.submit()">';
 for ($zaehler = 1971; $zaehler <= 2035; $zaehler++) {
 $auswahlJahr .= '  <option value="' . $zaehler . '"' .
  ((isset($_POST["jahr"]) ? $_POST["jahr"] : date("Y")) == $zaehler ? ' selected="selected"' : "") .
  '>' . $zaehler . '</option>';
}
$auswahlJahr .= ' </select>';

echo '<p>' . $auswahlMonat . '&nbsp; ' . $auswahlJahr .
 '&nbsp; <input type="submit" value="Anzeigen" formnovalidate="formnovalidate"></p>';


// Events auslesen
$select = $db->prepare("SELECT `id`,  `tag`, `monat`, `jahr`, `zeit`, `event`, `beschreibung`, `autor`
                                      FROM `" . $TABLE_PREFIX . "_kalender`
                                      WHERE `jahr` = :jahr AND `monat` = :monat
                                      ORDER BY `tag`, `zeit` ASC");
if ($select->execute([':jahr'=>$jahr,
                                ':monat'=>$monat])) {
 $events = $select->fetchAll(PDO::FETCH_OBJ);

 // Events ausgeben
 if ($select->rowCount() > 0) {
  echo "<table><tr><th>#</th><th>&#128197; Datum</th><th>&#128343; Uhr</th><th>&#128198; Event</th>
   <th>&#128196; Beschreibung</th><th>&#128100; Name</th></tr>";

  foreach ($events as $z => $event) {
   $h = date("G", $event->zeit);
   $i = date("i", $event->zeit);
     echo "<tr>
 <td>" . ($z+1) . "</td>
 <td>" .
  "<label><input type='radio' name='id' id='n" . $event->id . "' value='" . $event->id . "'" .
   " onClick='einfuegen(\"" .
                                         addSlashes($event->autor) . '", "' .
                                         $event->tag . '", "' .
                                         $event->monat . '", "' .
                                         $event->jahr . '", "' .
                                         $h . '", "' .
                                         $i . '", "' .
                                         addSlashes($event->event) . '", "' .
                                         (str_replace(["\r\n", "\'"], ["~"], addSlashes($event->beschreibung))) . "\");'>" .
     $event->tag . "." . $event->monat . "." . $event->jahr . " &thinsp;</label>
 </td>
 <td>" . (date("H:i", $event->zeit)) . "</td>
 <td> <label for='n" . $event->id . "'>" . $event->event . "</label> </td>
 <td> <label for='n" . $event->id . "'>" . mb_substr(strip_tags($event->beschreibung), 0, 45) . " &hellip;</label> </td>
 <td> <label for='n" . $event->id . "'>" . $event->autor . "</label> </td>
 </tr>";
  }
  echo "</table>";
 }
 else {
  echo '<p><span class="status">&#10149;</span> Keine Events vorhanden!</p>';
 }
}

// Uhrzeit
$zeit='943945200';
$h = date("H", $zeit);
$i = date("i", $zeit);
$uhr = '<label>&#128343; Uhrzeit: <select name="stunde" size="1">';
foreach (range(0, 23) as $stunde) {
 $uhr .= '<option' .  ($stunde == $h ? ' selected="selected"' : '') . '>' . sprintf("%02s", $stunde) . '</option>';
}
$uhr .= '</select></label>';
$uhr .= ' <label>: <select name="minute" size="1">';
foreach (range(0, 59) as $minute) {
 $uhr .= '<option' .  ($minute == $i ? ' selected="selected"' : '') . '>' . sprintf("%02s", $minute) . '</option>';
}
$uhr .= '</select></label>';
?>

<p>
 <input type="hidden" name="autor">&#128197; 
 <label>Tag: <input type="number" name="tagAktuell" value="<?=date("j");?>" min="1" max="31" maxlength="2" pattern="[0-9]{1,2}" required="required" autocomplete="off" style="width: 45px;"></label> &nbsp;
 <label>Monat: <input type="number" name="monatAktuell" value="<?=date("n");?>" min="1" max="12" maxlength="2" pattern="[0-9]{1,2}" required="required" autocomplete="off" style="width: 45px;"></label> &nbsp;
 <label>Jahr: <input type="number" name="jahrAktuell" value="<?=date("Y");?>" min="1971" max="2036" maxlength="4" pattern="[0-9]{4}" required="required" autocomplete="off" style="width: 60px;"></label> &emsp;
 <?=$uhr;?></p>

<p>
 <label>&#128198; <input type="text" name="event" size="45" maxlength="45" required="required" autocomplete="off" placeholder="Event"></label>
</p>

<p>
 <textarea name="beschreibung" rows="8" cols="40" placeholder="Beschreibung (Optional)"></textarea>
</p>

<p>
 <input type="button" value="Eingaben löschen" onDblClick="document.Form.reset();" title="Eingaben löschen -> doppelt klicken!">&nbsp;- 
 <select name="aktion" size="1" required="required">
  <option selected="selected"></option>
  <option value="eintragen">&#10004; Eintragen</option>
  <option value="aendern">&equiv; Ändern</option>
  <option value="loeschen">&#10008; Löschen</option>
 </select> 
 <input type="submit" name="execute" value="Ausführen">
 </p>

</fieldset>
</form>

</body>
</html>